;; -*-byte-compile-dynamic: t;-*-
;;; skk-study.el --- SKK $B3X=,8z2LDs6!%W%m%0%i%`(B
;; Copyright (C) 1999 Mikio Nakajima <minakaji@osaka.email.ne.jp>

;; Author: Mikio Nakajima <minakaji@osaka.email.ne.jp>
;; Maintainer: Mikio Nakajima <minakaji@osaka.email.ne.jp>
;; Version: $Id: skk-study.el,v 1.6 1999/04/11 14:16:31 minakaji Exp $
;; Keywords: japanese
;; Last Modified: $Date: 1999/04/11 14:16:31 $

;; This file is not part of SKK yet.

;; SKK is free software; you can redistribute it and/or modify
;; it under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either versions 2, or (at your option)
;; any later version.

;; SKK is distributed in the hope that it will be useful
;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with SKK, see the file COPYING.  If not, write to the Free
;; Software Foundation Inc., 59 Temple Place - Suite 330, Boston,
;; MA 02111-1307, USA.

;;; Commentary:
;;
;; $B$"$kC18l$rJQ49$7$?>l9g$K!"D>A0$KJQ49$7$?8l$r4XO"8l$H$7$FEPO?$7$F$*$-!":FEY$=(B
;; $B$NC18l$NJQ49$r9T$J$C$?$H$-$KEPO?$7$?4XO"8l$,<-=q$K$"$l$P$=$l$rM%@h$7$F=PNO$9(B
;; $B$kC1=c$J3X=,8z2L$rDs6!$9$k%W%m%0%i%`$G$9!#(B
;;
;; $B@N(B SKK ML $B$GOCBj$K$J$C$?C18l$NB0@-$NJ]B8$N$?$a$K!"(Bskk-attr.el $B$r:n$j$^$7$?(B
;; $B$,!"5!G=$rM_D%$j$9$.$F$b$N$K$J$j$^$;$s$G$7$?!#D>A0$NJQ49$H$N4XO"@-$rJ]B8$9$k$?(B
;; $B$a$@$1$K5!G=$r9J$C$F:F9=@.$7$?$N$,$3$N%W%m%0%i%`$G$9!#(B

;; <How to work>
;;
;; XEmacs $B$G(B SKK $B$r%Q%C%1!<%8%$%s%9%H!<%k$7$?>l9g$O!"(B.emacs $B$K(B
;;
;;   (setq skk-search-end-function 'skk-study-search)
;;   (setq skk-update-end-function 'skk-study-update)
;;
;; $B$H=q$/$@$1$G==J,$G$9!#$=$l0J30$NJ}$O!"(B
;;
;;   (add-hook 'skk-load-hook (function (lambda () (require 'skk-study))))
;;
;; $B$J$I$H=q$$$F2<$5$$!#(B

;; <DATA STRUCTURE (SKK-STUDY-ALIST)>
;;
;; (("$B8=:_$N(B HENKAN-KEY" . ((("$BD>A0$N(B HENKAN-KEY" . "$BD>A0$N4A;z(B") . ("HENKAN-KEY $B$r8+=P$78l$H$9$k4XO"8l(B" ...))
;;                          ... )))
;;
;;  o examples
;;
;; (("$B$-(Br" . ((("$B$U$/(B" . "$BI~(B") . ("$BCe(B"))
;; 	      (("$B$-(B" . "$BLZ(B") . ("$B@Z(B"))
;; 	      (("$B$($s(B" . "$B1o(B") . ("$B@Z(B")) ))
;;  ("$B$J(Bk" . ((("$B$3$I$b(B" . "$B;R6!(B") . ("$B5c(B"))
;; 	      (("$B$3$H$j(B" . "$B>.D;(B") . ("$BLD(B")) ))
;;  ("$B$+(Bk" . ((("$B$+$_(B" . "$B;f(B") . ("$B=q(B")) (("$B$R$s$+$/(B" . "$BIJ3J(B") . ("$B7g(B"))
;;  ("$B$+$_(B" . ((("$B$-(Br" . "$B@Z(B") . ("$B;f(B"))))
;;  ... )

;; <TODO>
;;
;; $B4XO"8l$NJ]B8$N%j%9%H$,@DE70f$GD9$/$J$k$N$G!"$3$l$r0lDj$ND9$50J>e$K$7$J$$$h$&(B
;; $B9)IW$9$k!#(B
;;
;;; Change log:

;;; Code:
(eval-when-compile (require 'skk))
(require 'skk-foreword)

(defgroup skk-study nil "SKK study related customization."
  :prefix "skk-study-"
  :group 'skk )

;;; user variables.
;;;###autoload
(defcustom skk-study-file (if (eq system-type 'ms-dos) "~/_skk-study" "~/.skk-study")
  "*$B3X=,7k2L$rJ]B8$9$k%U%!%$%k!#(B"
  :type 'file
  :group 'skk-study )

;;;###autoload
(defcustom skk-study-backup-file
  (if (eq system-type 'ms-dos) "~/_skk-study.BAK" "~/.skk-study.BAK" )
  "*$B3X=,7k2L$rJ]B8$9$k%P%C%/%"%C%W%U%!%$%k!#(B"
  :type 'file
  :group 'skk-study )
  
;;; system internal variables and constants.
;; global variable
(defvar skk-study-alist nil)
(defconst skk-study-working-buffer " *SKK study*")
(defconst skk-search-end-function 'skk-study-search)
(defconst skk-update-end-function 'skk-study-update)
(defconst skk-kakutei-end-function nil)

;;;###autoload
(defun skk-study-search (henkan-buffer midasi okurigana entry)
  (with-current-buffer henkan-buffer
    (let (
	  ;; buffer local variables.
	  last-key last-word
	  e assoc r )
      (or skk-study-alist (skk-study-read))
      (if (and skk-study-alist
	       (setq last-key (skk-get-last-henkan-data 'henkan-key))
	       (setq last-word (car (skk-get-last-henkan-data 'henkan-list)))
	       ;; e ::= ((("$B$U$/(B" . "$BI~(B") . ("$BCe(B")) (("$B$-(B" . "$BLZ(B") . ("$B@Z(B")))
	       (setq e (cdr (assoc midasi skk-study-alist)))
	       ;; assoc ::= ("$BCe(B")
	       (setq assoc (cdr (assoc (cons last-key last-word) e)))
	       (setq assoc (reverse assoc)) )
	  (while (setq r (car assoc))
	    (setq entry (cons r (delete r entry))
		  assoc (cdr assoc) )))
      entry )))

;;;###autoload
(defun skk-study-update (henkan-buffer midasi okurigana word purge)
  (with-current-buffer henkan-buffer
    (let (
	  ;; buffer local variables
	  last-key last-word
	  e assoc )
      (or skk-study-alist (skk-study-read))
      (cond ((and (setq last-key (skk-get-last-henkan-data 'henkan-key))
		  (setq last-word (car (skk-get-last-henkan-data 'henkan-list))) )
	     ;; e ::= ("$B$-(Br" . ((("$B$U$/(B" . "$BI~(B") . ("$BCe(B")) (("$B$-(B" . "$BLZ(B") . ("$B@Z(B"))))
	     (setq e (assoc midasi skk-study-alist))
	     (cond ((null e)
		    ;; car $B$K8+=P$78l$r;}$D(B cell $B$,$J$$(B
		    (cond ((not purge)
			   (setq skk-study-alist
				 (nconc (list
					 (cons midasi
					       (list (cons (cons last-key last-word) (list word)))
					       ))
					skk-study-alist )))))
		   ;; assoc ::= (("$B$U$/(B" . "$BI~(B") . ("$BCe(B"))
		   ((and (setq assoc (assoc (cons last-key last-word) (cdr e)))
			 (null assoc) )
		    ;; $B8+=P$78l$+$i;O$^$k(B cell $B$O$"$k$,!"(Bcdr $B$K(B (last-key . last-word) $B$r%-!<$K$7$?(B
		    ;; cell $B$,$J$$!#(B
		    (cond ((not purge)
			   (setcdr e (cons (cons (cons last-key last-word) (list word)) (cdr e))) )))
		   (t ; $B8+=P$78l$r%-!<$H$7$?4{B8$N(B cell $B9=B$$,$G$-$"$,$C$F$$$k$N$G!"4XO"8l$@$1%"%C%W%G!<%H$9$k!#(B
		    (cond ((not purge)
			   (setcdr assoc (cons word (delete word (cdr assoc)))) )
			  (t (setcdr e (delq assoc (cdr e)))) ))))))))

;;;###autoload
(defun skk-study-save (&optional nomsg)
  "skk-study-file $B$K3X=,7k2L$rJ]B8$9$k(B."
  (interactive "P")
  (if (and (null skk-study-alist) (not nomsg))
      (progn
        (skk-message "SKK $B$N3X=,7k2L$r%;!<%V$9$kI,MW$O$"$j$^$;$s(B"
                     "No SKK study need saving" )
        (sit-for 1) )
    (save-excursion
      (if (not nomsg)
          (skk-message "%s $B$K(B SKK $B$N3X=,7k2L$r%;!<%V$7$F$$$^$9(B..."
                       "Saving SKK study to %s..." skk-study-file ))
      (and skk-study-backup-file
	   (file-exists-p skk-study-backup-file)
           (copy-file skk-study-file skk-study-backup-file
                      'ok-if-already-exists 'keep-date ))
      (set-buffer (find-file-noselect skk-study-file))
      (delete-region 1 (point-max))
      (insert ";;; -*- emacs-lisp -*-\n;;; skk-study-file format version 0.1\n")
      ;; This makes slow down when we have a long attributes alist, but good
      ;; for debugging.
      ;;(if skk-debug (pp skk-study-alist (current-buffer))
      (skk-study-prin1 
       (sort skk-study-alist (function (lambda (a b) (string< (car a) (car b)))))
       (current-buffer) )
      (write-region-as-coding-system 
       (cond ((and skk-jisyo-code (coding-system-p skk-jisyo-code))
	      skk-jisyo-code )
	     ((and skk-jisyo-code (stringp skk-jisyo-code))
	      (cdr (assoc skk-jisyo-code skk-coding-system-alist)) )
	     (t (cdr (assoc "euc" skk-coding-system-alist))) )
       (point-min) (point-max) skk-study-file )
      (set-buffer-modified-p nil)
      (kill-buffer (current-buffer))
      (if (not nomsg)
          (progn
	    (skk-message "%s $B$K(B SKK $B3X=,7k2L$r%;!<%V$7$F$$$^$9(B...$B40N;!*(B"
			 "Saving SKK study to %s...done" skk-study-file )
	    (sit-for 1) )))))
  
;;;###autoload
(defun skk-study-read (&optional nomsg)
  "skk-study-file $B$+$i3X=,7k2L$rFI$_9~$`!#(B"
  (interactive "P")
  (skk-create-file
   skk-study-file
   (if (not nomsg)
       (if skk-japanese-message-and-error
           "SKK $B$N3X=,7k2L%U%!%$%k$r:n$j$^$7$?(B"
         "I have created an SKK study file for you" )))
  (if (or (null skk-study-alist)
          (skk-yes-or-no-p (format "%s $B$r:FFI$_9~$_$7$^$9$+!)(B" skk-study-file)
                           (format "Reread %s?" skk-study-file) ))
      (let (enable-character-unification)
        (save-excursion
          (unwind-protect
              (progn
                (set-buffer (get-buffer-create skk-study-working-buffer))
                (erase-buffer)
		(insert-file-contents-as-coding-system
		 (cond ((and skk-jisyo-code (coding-system-p skk-jisyo-code))
			skk-jisyo-code )
		       ((and skk-jisyo-code (stringp skk-jisyo-code))
			(cdr (assoc skk-jisyo-code skk-coding-system-alist)) )
		       (t (cdr (assoc "euc" skk-coding-system-alist))) )
		 skk-study-file )
		(if (not (= (buffer-size) 0))
		    (progn
		      (goto-char (point-min))
		      (or nomsg
			  (skk-message "%s $B$N(B SKK $B3X=,7k2L$rE83+$7$F$$$^$9(B..."
				       "Expanding SKK study of %s ..."
				       (file-name-nondirectory skk-study-file) ))
		      (setq skk-study-alist (read (current-buffer)))
		      (or nomsg
			  (progn
			    (skk-message
			     "%s $B$N(B SKK $B3X=,7k2L$rE83+$7$F$$$^$9(B...$B40N;!*(B"
			     "Expanding SKK study of %s ...done"
			     (file-name-nondirectory skk-study-file) )
			    (sit-for 1) )))))
	    (kill-buffer (current-buffer)) )
	  skk-study-alist ))))

(defun skk-study-prin1 (form &optional stream)
  (let ((print-readably t)
	print-level print-length print-quoted )
    (prin1 form stream) ))

(add-hook 'skk-before-kill-emacs-hook 'skk-study-save)
(provide 'skk-study)
;;; Local Variables:
;;; End:
;;; skk-study.el ends here
